import * as i0 from '@angular/core';
import { Component, Input, Pipe, forwardRef, EventEmitter, ChangeDetectionStrategy, Output, NgModule } from '@angular/core';
import * as i1 from '@angular/forms';
import { NG_VALUE_ACCESSOR, ReactiveFormsModule } from '@angular/forms';
import { Subject, takeUntil } from 'rxjs';
import * as i1$1 from '@ngx-translate/core';
import { TranslateModule } from '@ngx-translate/core';
import * as i2 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i4$1 from '@angular/material/tabs';
import { MatTabsModule } from '@angular/material/tabs';
import * as i3 from '@angular/material/form-field';
import * as i4 from '@angular/material/select';
import { MatSelectModule } from '@angular/material/select';
import * as i5 from '@angular/material/core';
import * as i8 from '@angular/material/input';
import { MatInputModule } from '@angular/material/input';
import * as i9 from '@angular/material/radio';
import { MatRadioModule } from '@angular/material/radio';
import * as i10 from '@angular/material/checkbox';
import { MatCheckboxModule } from '@angular/material/checkbox';
import { MatListModule } from '@angular/material/list';
import { MatDatepickerModule } from '@angular/material/datepicker';

/* eslint-disable no-shadow */
const Days = [
    { 0: 'SUN' },
    { 1: 'MON' },
    { 2: 'TUE' },
    { 3: 'WED' },
    { 4: 'THU' },
    { 5: 'FRI' },
    { 6: 'SAT' }
];
const MonthWeeks = {
    '#1': 'first',
    '#2': 'second',
    '#3': 'third',
    '#4': 'fourth',
    '#5': 'fifth',
    L: 'last'
};
const Months = {
    1: 'january',
    2: 'february',
    3: 'march',
    4: 'april',
    5: 'may',
    6: 'june',
    7: 'july',
    8: 'august',
    9: 'september',
    10: 'october',
    11: 'november',
    12: 'december'
};
var Tabs;
(function (Tabs) {
    Tabs["minutes"] = "minutes";
    Tabs["hourly"] = "hourly";
    Tabs["daily"] = "daily";
    Tabs["weekly"] = "weekly";
    Tabs["monthly"] = "monthly";
    Tabs["yearly"] = "yearly";
    Tabs["advanced"] = "advanced";
    Tabs["repeat"] = "repeat";
})(Tabs || (Tabs = {}));

function* range(start, end) {
    for (let i = start; i <= end; i += 1) {
        yield i;
    }
}
class TimePickerComponent {
    get hour12Format() {
        return this.hourTab ? [...range(1, 12)] : [...range(0, 12)];
    }
    get hour24Format() {
        return this.hourTab ? [...range(1, 24)] : [...range(0, 24)];
    }
    get hours() {
        return this.use24HourTime ? this.hour24Format : this.hour12Format;
    }
    constructor(parent) {
        this.parent = parent;
        this.use24HourTime = true;
        this.hideHours = false;
        this.hideMinutes = false;
        this.hideSeconds = true;
        this.hourTab = false;
        this.minutes = [];
        this.seconds = [...range(0, 59)];
        this.hourTypes = ['AM', 'PM'];
        this.minutes = [...range(0, 59)].map(x => x.toString().padStart(2, '0'));
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.7", ngImport: i0, type: TimePickerComponent, deps: [{ token: i1.ControlContainer }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.7", type: TimePickerComponent, selector: "cron-time-picker", inputs: { disabled: "disabled", use24HourTime: "use24HourTime", hideHours: "hideHours", hideMinutes: "hideMinutes", hideSeconds: "hideSeconds", hourTab: "hourTab" }, providers: [], ngImport: i0, template: "<span [formGroup]=\"parent.control\">\r\n\r\n  <mat-form-field class=\"field-width-100\" *ngIf=\"!hideHours\">\r\n    <mat-label>{{ 'cronEditor.lbl.hours' | translate }}</mat-label>\r\n    <mat-select formControlName=\"hours\">\r\n      <mat-option *ngFor=\"let hour of hours\" [value]=\"hour\">{{hour}}</mat-option>\r\n    </mat-select>\r\n  </mat-form-field>\r\n\r\n  <span *ngIf=\"!hideHours\">:</span>\r\n  <mat-form-field class=\"field-width-100\" *ngIf=\"!hideMinutes\">\r\n    <mat-label>{{ 'cronEditor.lbl.minutes' | translate }}</mat-label>\r\n    <mat-select formControlName=\"minutes\">\r\n      <mat-option *ngFor=\"let minute of minutes\" [value]=\"minute\">{{minute}}</mat-option>\r\n    </mat-select>\r\n  </mat-form-field>\r\n\r\n  <span *ngIf=\"!hideSeconds\">:</span>\r\n  <mat-form-field class=\"field-width-100\" *ngIf=\"!hideSeconds\">\r\n    <mat-label>{{ 'cronEditor.lbl.seconds' | translate }}</mat-label>\r\n    <mat-select formControlName=\"seconds\">\r\n      <mat-option *ngFor=\"let second of seconds\" [value]=\"second\">{{second}}</mat-option>\r\n    </mat-select>\r\n  </mat-form-field>\r\n\r\n  <ng-container *ngIf=\"!use24HourTime\">\r\n    <span></span>.\r\n    <mat-form-field class=\"field-width-100\">\r\n      <mat-select formControlName=\"hourType\">\r\n        <mat-option *ngFor=\"let hourType of hourTypes\" [value]=\"hourType\">{{hourType}}</mat-option>\r\n      </mat-select>\r\n    </mat-form-field>\r\n  </ng-container>\r\n</span>\r\n", styles: [".cron-editor-tab-content{height:200px;margin-top:24px;margin-left:24px;border-radius:8px}.to-lowercase{text-transform:lowercase}.check-weekday{margin-left:12px}.field-width-100 ::ng-deep .mat-form-field-infix{width:100px}.column-stretch-start{display:flex;flex-flow:column;justify-content:start;align-items:stretch}\n"], dependencies: [{ kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { kind: "directive", type: i1.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { kind: "directive", type: i1.FormControlName, selector: "[formControlName]", inputs: ["formControlName", "disabled", "ngModel"], outputs: ["ngModelChange"] }, { kind: "component", type: i3.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i3.MatLabel, selector: "mat-label" }, { kind: "component", type: i4.MatSelect, selector: "mat-select", inputs: ["disabled", "disableRipple", "tabIndex", "hideSingleSelectionIndicator"], exportAs: ["matSelect"] }, { kind: "component", type: i5.MatOption, selector: "mat-option", exportAs: ["matOption"] }, { kind: "pipe", type: i1$1.TranslatePipe, name: "translate" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.7", ngImport: i0, type: TimePickerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'cron-time-picker', providers: [], template: "<span [formGroup]=\"parent.control\">\r\n\r\n  <mat-form-field class=\"field-width-100\" *ngIf=\"!hideHours\">\r\n    <mat-label>{{ 'cronEditor.lbl.hours' | translate }}</mat-label>\r\n    <mat-select formControlName=\"hours\">\r\n      <mat-option *ngFor=\"let hour of hours\" [value]=\"hour\">{{hour}}</mat-option>\r\n    </mat-select>\r\n  </mat-form-field>\r\n\r\n  <span *ngIf=\"!hideHours\">:</span>\r\n  <mat-form-field class=\"field-width-100\" *ngIf=\"!hideMinutes\">\r\n    <mat-label>{{ 'cronEditor.lbl.minutes' | translate }}</mat-label>\r\n    <mat-select formControlName=\"minutes\">\r\n      <mat-option *ngFor=\"let minute of minutes\" [value]=\"minute\">{{minute}}</mat-option>\r\n    </mat-select>\r\n  </mat-form-field>\r\n\r\n  <span *ngIf=\"!hideSeconds\">:</span>\r\n  <mat-form-field class=\"field-width-100\" *ngIf=\"!hideSeconds\">\r\n    <mat-label>{{ 'cronEditor.lbl.seconds' | translate }}</mat-label>\r\n    <mat-select formControlName=\"seconds\">\r\n      <mat-option *ngFor=\"let second of seconds\" [value]=\"second\">{{second}}</mat-option>\r\n    </mat-select>\r\n  </mat-form-field>\r\n\r\n  <ng-container *ngIf=\"!use24HourTime\">\r\n    <span></span>.\r\n    <mat-form-field class=\"field-width-100\">\r\n      <mat-select formControlName=\"hourType\">\r\n        <mat-option *ngFor=\"let hourType of hourTypes\" [value]=\"hourType\">{{hourType}}</mat-option>\r\n      </mat-select>\r\n    </mat-form-field>\r\n  </ng-container>\r\n</span>\r\n", styles: [".cron-editor-tab-content{height:200px;margin-top:24px;margin-left:24px;border-radius:8px}.to-lowercase{text-transform:lowercase}.check-weekday{margin-left:12px}.field-width-100 ::ng-deep .mat-form-field-infix{width:100px}.column-stretch-start{display:flex;flex-flow:column;justify-content:start;align-items:stretch}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.ControlContainer }]; }, propDecorators: { disabled: [{
                type: Input
            }], use24HourTime: [{
                type: Input
            }], hideHours: [{
                type: Input
            }], hideMinutes: [{
                type: Input
            }], hideSeconds: [{
                type: Input
            }], hourTab: [{
                type: Input
            }] } });

class MonthDayDisplayPipe {
    constructor(translateService) {
        this.translateService = translateService;
    }
    transform(month) {
        if (!this.translateService.currentLang) {
            this.translateService.use('en');
        }
        if (month === 'L') {
            return this.translateService.instant('cronEditor.lbl.lastDay');
        }
        return month;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.7", ngImport: i0, type: MonthDayDisplayPipe, deps: [{ token: i1$1.TranslateService }], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "16.2.7", ngImport: i0, type: MonthDayDisplayPipe, name: "monthDayDisplay" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.7", ngImport: i0, type: MonthDayDisplayPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'monthDayDisplay'
                }]
        }], ctorParameters: function () { return [{ type: i1$1.TranslateService }]; } });

/**
 * Useful for english translations of month days only
 */
class OrdinalSuffixPipe {
    constructor(translateService) {
        this.translateService = translateService;
    }
    transform(value, language = 'en') {
        if (language === 'en') {
            if (value.length > 1) {
                const secondToLastDigit = value.charAt(value.length - 2);
                if (secondToLastDigit === '1') {
                    return `${value}th`;
                }
                if (value.length > 2) {
                    return value;
                }
            }
            const lastDigit = value.charAt(value.length - 1);
            switch (lastDigit) {
                case '1':
                    return `${value}st`;
                case '2':
                    return `${value}nd`;
                case '3':
                    return `${value}rd`;
                default:
                    return `${value}th`;
            }
        }
        return value;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.7", ngImport: i0, type: OrdinalSuffixPipe, deps: [{ token: i1$1.TranslateService }], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "16.2.7", ngImport: i0, type: OrdinalSuffixPipe, name: "ordinalSuffix" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.7", ngImport: i0, type: OrdinalSuffixPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'ordinalSuffix'
                }]
        }], ctorParameters: function () { return [{ type: i1$1.TranslateService }]; } });

/* eslint-disable class-methods-use-this */
/**
 * build the cron from this form.
 * <app-cron-editor
    [options]="cronOptions"
    [cronStartingValue]="cronValue"
    (cronChange)="seeCron($event)">
   </app-cron-editor>
 */
const CRON_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    // eslint-disable-next-line no-use-before-define
    useExisting: forwardRef(() => CronEditorComponent),
    multi: true
};
class CronEditorComponent {
    /** get the value from the input value and use it around the component */
    get cron() {
        return this.cronStartingValue;
    }
    /** set the cron around this component */
    set cron(value) {
        this.onChange(value);
        this.cronChange.emit(value);
    }
    get isCronFlavorQuartz() {
        return this.options.cronFlavor === 'quartz';
    }
    get isCronFlavorStandard() {
        return this.options.cronFlavor === 'standard';
    }
    get yearDefaultChar() {
        return this.options.cronFlavor === 'quartz' ? '*' : '';
    }
    get weekDayDefaultChar() {
        return this.options.cronFlavor === 'quartz' ? '?' : '*';
    }
    get monthDayDefaultChar() {
        return this.options.cronFlavor === 'quartz' ? '?' : '*';
    }
    constructor(fb, translateService) {
        this.fb = fb;
        this.translateService = translateService;
        this.cronChange = new EventEmitter();
        this.vaildExpression = new EventEmitter();
        /** build the options of the cron form */
        this.selectOptions = this.getSelectOptions();
        this.isValid = false;
        this.MonthWeeks = MonthWeeks;
        this.Months = Months;
        this.currentLanguage = 'en';
        /** it varies due to the option JSON */
        this.tabList = [];
        this.unsub$ = new Subject();
        this.firstChange = 0;
        /*
         * ControlValueAccessor
         */
        this.onChange = (_) => { };
        this.onTouched = () => { };
    }
    ngOnChanges(changes) {
        if (changes.cronStartingValue.firstChange) {
            this.firstChange++;
        }
        if (this.state && this.firstChange) {
            const prevTab = this.activeTab;
            this.handleModelChange(this.cron);
            if (prevTab != this.activeTab || this.firstChange) {
                this.createForm();
            }
            this.firstChange = 0;
        }
        if (changes.options) {
            this.selectOptions = this.getSelectOptions();
        }
    }
    ngOnInit() {
        this.currentLanguage = this.translateService.currentLang;
        // start with initial values of the whole form
        this.state = this.getInitialState();
        // tab list with the tabs passed in the options
        this.createTabList();
        // populate the state with cron passed in input
        this.handleModelChange(this.cron);
        this.createForm();
    }
    createForm() {
        // use the state created above for the form groups of different tabs
        if (!this.options.hideMinutesTab) {
            this.minutesForm = this.fb.group(this.state.minutes);
            this.minutesForm.valueChanges.subscribe((value) => this.computeMinutesCron(value));
        }
        if (!this.options.hideHourlyTab) {
            this.hourlyForm = this.fb.group(this.state.hourly);
            this.hourlyForm.valueChanges.subscribe((value) => this.computeHourlyCron(value));
        }
        if (!this.options.hideDailyTab) {
            this.dailyForm = this.fb.group({
                subTab: this.state.daily.subTab,
                everyDays: this.fb.group(this.state.daily.everyDays),
                everyWeekDay: this.fb.group(this.state.daily.everyWeekDay)
            });
            this.dailyForm.valueChanges.subscribe((value) => this.computeDailyCron(value));
        }
        if (!this.options.hideWeeklyTab) {
            this.weeklyForm = this.fb.group(this.state.weekly);
            this.weeklyForm.valueChanges.subscribe((next) => this.computeWeeklyCron(next));
        }
        if (!this.options.hideMonthlyTab) {
            this.monthlyForm = this.fb.group({
                subTab: this.state.monthly.subTab,
                specificDay: this.fb.group(this.state.monthly.specificDay),
                specificWeekDay: this.fb.group(this.state.monthly.specificWeekDay)
            });
            this.monthlyForm.valueChanges.subscribe((next) => this.computeMonthlyCron(next));
        }
        if (!this.options.hideYearlyTab) {
            this.yearlyForm = this.fb.group({
                subTab: this.state.yearly.subTab,
                specificMonthDay: this.fb.group(this.state.yearly.specificMonthDay),
                specificMonthWeek: this.fb.group(this.state.yearly.specificMonthWeek)
            });
            this.yearlyForm.valueChanges.subscribe((next) => this.computeYearlyCron(next));
        }
        if (!this.options.hideAdvancedTab) {
            this.advancedForm = this.fb.group({
                expression: this.cron
            });
            this.advancedForm.controls.expression.valueChanges.subscribe((next) => this.computeAdvancedExpression(next));
        }
        // translate observable that emits on language changed
        this.translateService.onLangChange
            .pipe(takeUntil(this.unsub$))
            .subscribe((translate) => {
            this.currentLanguage = translate.lang;
        });
    }
    /**
     * Based on the hide... options create the list of tabs
     */
    createTabList() {
        if (!this.options.hideMinutesTab) {
            this.tabList.push(Tabs.minutes);
        }
        if (!this.options.hideHourlyTab) {
            this.tabList.push(Tabs.hourly);
        }
        if (!this.options.hideDailyTab) {
            this.tabList.push(Tabs.daily);
        }
        if (!this.options.hideWeeklyTab) {
            this.tabList.push(Tabs.weekly);
        }
        if (!this.options.hideMonthlyTab) {
            this.tabList.push(Tabs.monthly);
        }
        if (!this.options.hideYearlyTab) {
            this.tabList.push(Tabs.yearly);
        }
        if (!this.options.hideAdvancedTab) {
            this.tabList.push(Tabs.advanced);
        }
    }
    computeMinutesCron(state) {
        this.cron = `${this.isCronFlavorQuartz ? state.seconds : ''} 0/${state.minutes} * * * ${this.weekDayDefaultChar} ${this.yearDefaultChar}`.trim();
    }
    computeHourlyCron(state) {
        this.cron =
            `${this.isCronFlavorQuartz ? state.seconds : ''} ${state.minutes} 0/${state.hours} * * ${this.weekDayDefaultChar} ${this.yearDefaultChar}`.trim();
    }
    computeDailyCron(state) {
        switch (state.subTab) {
            case 'everyDays':
                this.cron = `${this.isCronFlavorQuartz ? state.everyDays.seconds : ''} ${state.everyDays.minutes} ${this.hourToCron(state.everyDays.hours, state.everyDays.hourType)} ${state.everyDays.from}/${state.everyDays.days} * ${this.weekDayDefaultChar} ${this.yearDefaultChar}`.trim();
                break;
            case 'everyWeekDay':
                this.cron = `${this.isCronFlavorQuartz ? state.everyWeekDay.seconds : ''} ${state.everyWeekDay.minutes} ${this.hourToCron(state.everyWeekDay.hours, state.everyWeekDay.hourType)} ${this.monthDayDefaultChar} * MON-FRI ${this.yearDefaultChar}`.trim();
                break;
            default:
                throw new Error('Invalid cron daily subtab selection');
        }
    }
    computeWeeklyCron(state) {
        const days = this.selectOptions.days
            .reduce((acc, day) => (state[day] ? acc.concat([day]) : acc), [])
            .join(',');
        this.cron = `${this.isCronFlavorQuartz ? state.seconds : ''} ${state.minutes} ${this.hourToCron(state.hours, state.hourType)} ${this.monthDayDefaultChar} * ${days} ${this.yearDefaultChar}`.trim();
    }
    computeMonthlyCron(state) {
        switch (state.subTab) {
            case 'specificDay':
                this.cron = `${this.isCronFlavorQuartz ? state.specificDay.seconds : ''} ${state.specificDay.minutes} ${this.hourToCron(state.specificDay.hours, state.specificDay.hourType)} ${state.specificDay.day} 1/${state.specificDay.months} ${this.weekDayDefaultChar} ${this.yearDefaultChar}`.trim();
                break;
            case 'specificWeekDay':
                this.cron = `${this.isCronFlavorQuartz ? state.specificWeekDay.seconds : ''} ${state.specificWeekDay.minutes} ${this.hourToCron(state.specificWeekDay.hours, state.specificWeekDay.hourType)} ${this.monthDayDefaultChar} 1/${state.specificWeekDay.months} ${this.getSelectOptions().days.indexOf(state.specificWeekDay.day) + 1}${state.specificWeekDay.monthWeek} ${this.yearDefaultChar}`.trim();
                break;
            default:
                throw new Error('Invalid cron monthly subtab selection');
        }
    }
    computeYearlyCron(state) {
        switch (state.subTab) {
            case 'specificMonthDay':
                this.cron = `${this.isCronFlavorQuartz ? state.specificMonthDay.seconds : ''} ${state.specificMonthDay.minutes} ${this.hourToCron(state.specificMonthDay.hours, state.specificMonthDay.hourType)} ${state.specificMonthDay.day} ${state.specificMonthDay.month} ${this.weekDayDefaultChar} ${this.yearDefaultChar}`.trim();
                break;
            case 'specificMonthWeek':
                this.cron = `${this.isCronFlavorQuartz ? state.specificMonthWeek.seconds : ''} ${state.specificMonthWeek.minutes} ${this.hourToCron(state.specificMonthWeek.hours, state.specificMonthWeek.hourType)} ${this.monthDayDefaultChar} ${state.specificMonthWeek.month} ${this.getSelectOptions().days.indexOf(state.specificMonthWeek.day) + 1}${state.specificMonthWeek.monthWeek} ${this.yearDefaultChar}`.trim();
                break;
            default:
                throw new Error('Invalid cron yearly subtab selection');
        }
    }
    computeAdvancedExpression(expression) {
        this.cron = expression;
    }
    getAmPmHour(hour) {
        return this.options.use24HourTime ? hour : ((hour + 11) % 12) + 1;
    }
    getHourType(hour) {
        if (this.options.use24HourTime) {
            return undefined;
        }
        if (hour >= 12) {
            return 'PM';
        }
        return 'AM';
    }
    hourToCron(hour, hourType) {
        if (this.options.use24HourTime) {
            return hour;
        }
        if (hourType === 'AM') {
            return hour === 12 ? 0 : hour;
        }
        if (hour === 12) {
            return 12;
        }
        return hour + 12;
    }
    /**
     * Populate the state with the cron expression
     * passed as input to this component
     *
     * @param cron cronExpression coming from the input
     */
    handleModelChange(cron) {
        if (this.isDirty) {
            this.isDirty = false;
            return;
        }
        this.isDirty = false;
        this.populateTab(cron);
    }
    /**
     * Check cron expression and see what tab to populate
     *
     * @param cron cron expression
     * @returns nothing
     */
    populateTab(cron) {
        if (cron.split(' ').length === 5 && this.isCronFlavorStandard) {
            // eslint-disable-next-line no-param-reassign
            cron = `0 ${cron} *`;
        }
        if (cron.match(/\d+ 0\/\d+ \* \* \* [?*] \*/)) {
            this.minutes(cron);
            return;
        }
        if (cron.match(/\d+ \d+ 0\/\d+ \* \* [?*] \*/)) {
            this.hourly(cron);
            return;
        }
        if (cron.match(/\d+ \d+ \d+ \d+\/\d+ \* [?*] \*/)) {
            this.dailyEveryDays(cron);
            return;
        }
        if (cron.match(/\d+ \d+ \d+ [?*] \* MON-FRI \*/)) {
            this.dailyEveryWeekDay(cron);
            return;
        }
        if (cron.match(/\d+ \d+ \d+ [?*] \* (MON|TUE|WED|THU|FRI|SAT|SUN)(,(MON|TUE|WED|THU|FRI|SAT|SUN))* \*/)) {
            this.weekly(cron);
            return;
        }
        if (cron.match(/\d+ \d+ \d+ (\d+|L|LW|1W) 1\/\d+ [?*] \*/)) {
            this.monthlySpecificDay(cron);
            return;
        }
        if (cron.match(/\d+ \d+ \d+ [?*] 1\/\d+ ([1-7])((#[1-5])|L) \*/)) {
            this.monthlySpecificWeekDay(cron);
            return;
        }
        if (cron.match(/\d+ \d+ \d+ (\d+|L|LW|1W) \d+ [?*] \*/)) {
            this.yearlySpecificMonthDay(cron);
            return;
        }
        if (cron.match(/\d+ \d+ \d+ [?*] \d+ ([1-7])((#[1-5])|L) \*/)) {
            this.yearlySpecificMonthWeek(cron);
            return;
        }
        // ADVANCED TAB
        this.advance(cron);
    }
    advance(cron) {
        this.activeTab = this.tabList.indexOf(Tabs.advanced);
        const origCron = cron;
        this.state.advanced.expression = origCron;
    }
    minutes(cron) {
        this.activeTab = this.tabList.indexOf(Tabs.minutes);
        const [seconds, minutes] = cron.split(' ');
        this.state.minutes.minutes = parseInt(minutes.substring(2), 10).toString().padStart(2, '0');
        this.state.minutes.seconds = parseInt(seconds, 10);
    }
    hourly(cron) {
        this.activeTab = this.tabList.indexOf(Tabs.hourly);
        const [seconds, minutes, hours] = cron.split(' ');
        this.state.hourly.hours = parseInt(hours.substring(2), 10);
        this.state.hourly.minutes = parseInt(minutes, 10).toString().padStart(2, '0');
        this.state.hourly.seconds = parseInt(seconds, 10);
    }
    dailyEveryDays(cron) {
        this.activeTab = this.tabList.indexOf(Tabs.daily);
        const [seconds, minutes, hours, dayOfMonth] = cron.split(' ');
        this.state.daily.subTab = 'everyDays';
        const [from, days] = dayOfMonth.split('/').map((n) => parseInt(n, 10));
        this.state.daily.everyDays.from = from;
        this.state.daily.everyDays.days = days;
        const parsedHours = parseInt(hours, 10);
        this.state.daily.everyDays.hours = this.getAmPmHour(parsedHours);
        this.state.daily.everyDays.hourType = this.getHourType(parsedHours);
        this.state.daily.everyDays.minutes = parseInt(minutes, 10).toString().padStart(2, '0');
        this.state.daily.everyDays.seconds = parseInt(seconds, 10);
    }
    dailyEveryWeekDay(cron) {
        this.activeTab = this.tabList.indexOf(Tabs.daily);
        const [seconds, minutes, hours] = cron.split(' ');
        this.state.daily.subTab = 'everyWeekDay';
        const parsedHours = parseInt(hours, 10);
        this.state.daily.everyWeekDay.hours = this.getAmPmHour(parsedHours);
        this.state.daily.everyWeekDay.hourType = this.getHourType(parsedHours);
        this.state.daily.everyWeekDay.minutes = parseInt(minutes, 10).toString().padStart(2, '0');
        this.state.daily.everyWeekDay.seconds = parseInt(seconds, 10);
    }
    weekly(cron) {
        this.activeTab = this.tabList.indexOf(Tabs.weekly);
        const [seconds, minutes, hours, dayOfMonth, month, dayOfWeek] = cron.split(' ');
        this.selectOptions.days.forEach((weekDay) => {
            this.state.weekly[weekDay] = false;
        });
        dayOfWeek.split(',').forEach((weekDay) => {
            this.state.weekly[weekDay] = true;
        });
        const parsedHours = parseInt(hours, 10);
        this.state.weekly.hours = this.getAmPmHour(parsedHours);
        this.state.weekly.hourType = this.getHourType(parsedHours);
        this.state.weekly.minutes = parseInt(minutes, 10).toString().padStart(2, '0');
        this.state.weekly.seconds = parseInt(seconds, 10);
    }
    monthlySpecificDay(cron) {
        this.activeTab = this.tabList.indexOf(Tabs.monthly);
        const [seconds, minutes, hours, dayOfMonth, month] = cron.split(' ');
        this.state.monthly.subTab = 'specificDay';
        this.state.monthly.specificDay.day = dayOfMonth;
        this.state.monthly.specificDay.months = parseInt(month.substring(2), 10);
        const parsedHours = parseInt(hours, 10);
        this.state.monthly.specificDay.hours = this.getAmPmHour(parsedHours);
        this.state.monthly.specificDay.hourType = this.getHourType(parsedHours);
        this.state.monthly.specificDay.minutes = parseInt(minutes, 10).toString().padStart(2, '0');
        this.state.monthly.specificDay.seconds = parseInt(seconds, 10);
    }
    monthlySpecificWeekDay(cron) {
        this.activeTab = this.tabList.indexOf(Tabs.monthly);
        const [seconds, minutes, hours, dayOfMonth, month, dayOfWeek] = cron.split(' ');
        const day = dayOfWeek[0];
        const monthWeek = dayOfWeek.slice(1);
        this.state.monthly.subTab = 'specificWeekDay';
        this.state.monthly.specificWeekDay.monthWeek = monthWeek;
        this.state.monthly.specificWeekDay.day = this.getSelectOptions().days[+day - 1];
        this.state.monthly.specificWeekDay.months = parseInt(month.substring(2), 10);
        const parsedHours = parseInt(hours, 10);
        this.state.monthly.specificWeekDay.hours = this.getAmPmHour(parsedHours);
        this.state.monthly.specificWeekDay.hourType = this.getHourType(parsedHours);
        this.state.monthly.specificWeekDay.minutes = parseInt(minutes, 10).toString().padStart(2, '0');
        this.state.monthly.specificWeekDay.seconds = parseInt(seconds, 10);
    }
    yearlySpecificMonthDay(cron) {
        this.activeTab = this.tabList.indexOf(Tabs.yearly);
        const [seconds, minutes, hours, dayOfMonth, month] = cron.split(' ');
        this.state.yearly.subTab = 'specificMonthDay';
        this.state.yearly.specificMonthDay.month = parseInt(month, 10);
        this.state.yearly.specificMonthDay.day = dayOfMonth;
        const parsedHours = parseInt(hours, 10);
        this.state.yearly.specificMonthDay.hours = this.getAmPmHour(parsedHours);
        this.state.yearly.specificMonthDay.hourType = this.getHourType(parsedHours);
        this.state.yearly.specificMonthDay.minutes = parseInt(minutes, 10).toString().padStart(2, '0');
        this.state.yearly.specificMonthDay.seconds = parseInt(seconds, 10);
    }
    yearlySpecificMonthWeek(cron) {
        this.activeTab = this.tabList.indexOf(Tabs.yearly);
        const [seconds, minutes, hours, dayOfMonth, month, dayOfWeek] = cron.split(' ');
        const day = dayOfWeek[0];
        const monthWeek = dayOfWeek.slice(1);
        this.state.yearly.subTab = 'specificMonthWeek';
        this.state.yearly.specificMonthWeek.monthWeek = monthWeek;
        this.state.yearly.specificMonthWeek.day = this.getSelectOptions().days[+day - 1];
        this.state.yearly.specificMonthWeek.month = parseInt(month, 10);
        const parsedHours = parseInt(hours, 10);
        this.state.yearly.specificMonthWeek.hours = this.getAmPmHour(parsedHours);
        this.state.yearly.specificMonthWeek.hourType = this.getHourType(parsedHours);
        this.state.yearly.specificMonthWeek.minutes = parseInt(minutes, 10).toString().padStart(2, '0');
        this.state.yearly.specificMonthWeek.seconds = parseInt(seconds, 10);
    }
    cronIsValid(cron) {
        if (cron) {
            const cronParts = cron.split(' ');
            return ((this.isCronFlavorQuartz && (cronParts.length === 6 || cronParts.length === 7)) ||
                (this.isCronFlavorStandard && cronParts.length === 5));
        }
        return false;
    }
    /**
     * Initialize state of the schedulation
     * with hard coded values
     *
     */
    getInitialState() {
        const defaultHours = 0;
        const defaultMinutes = '00';
        const defaultSeconds = 0;
        const defaultStartDay = 1;
        return {
            minutes: {
                minutes: 1,
                seconds: 0
            },
            hourly: {
                hours: 1,
                minutes: '00',
                seconds: 0
            },
            daily: {
                subTab: 'everyDays',
                everyDays: {
                    days: 1,
                    hours: this.getAmPmHour(defaultHours),
                    minutes: defaultMinutes,
                    seconds: defaultSeconds,
                    hourType: this.getHourType(defaultHours),
                    from: defaultStartDay
                },
                everyWeekDay: {
                    hours: this.getAmPmHour(defaultHours),
                    minutes: defaultMinutes,
                    seconds: defaultSeconds,
                    hourType: this.getHourType(defaultHours)
                }
            },
            weekly: {
                MON: true,
                TUE: false,
                WED: false,
                THU: false,
                FRI: false,
                SAT: false,
                SUN: false,
                hours: this.getAmPmHour(defaultHours),
                minutes: defaultMinutes,
                seconds: defaultSeconds,
                hourType: this.getHourType(defaultHours)
            },
            monthly: {
                subTab: 'specificDay',
                specificDay: {
                    day: '1',
                    months: 1,
                    hours: this.getAmPmHour(defaultHours),
                    minutes: defaultMinutes,
                    seconds: defaultSeconds,
                    hourType: this.getHourType(defaultHours)
                },
                specificWeekDay: {
                    monthWeek: '#1',
                    day: 'MON',
                    months: 1,
                    hours: this.getAmPmHour(defaultHours),
                    minutes: defaultMinutes,
                    seconds: defaultSeconds,
                    hourType: this.getHourType(defaultHours)
                }
            },
            yearly: {
                subTab: 'specificMonthDay',
                specificMonthDay: {
                    month: 1,
                    day: '1',
                    hours: this.getAmPmHour(defaultHours),
                    minutes: defaultMinutes,
                    seconds: defaultSeconds,
                    hourType: this.getHourType(defaultHours)
                },
                specificMonthWeek: {
                    monthWeek: '#1',
                    day: 'MON',
                    month: 1,
                    hours: this.getAmPmHour(defaultHours),
                    minutes: defaultMinutes,
                    seconds: defaultSeconds,
                    hourType: this.getHourType(defaultHours)
                }
            },
            advanced: {
                expression: this.isCronFlavorQuartz ? '0 15 10 L-2 * ? *' : '15 10 2 * *'
            }
        };
    }
    getSelectOptions() {
        let days = [];
        if (this.options?.weekStart) {
            const tempDays = [...Days.slice(this.options.weekStart, Days.length), ...Days.slice(0, this.options.weekStart)];
            days = tempDays.map((x) => Object.values(x)).flat();
        }
        return {
            months: this.getRange(1, 12),
            monthWeeks: ['#1', '#2', '#3', '#4', '#5', 'L'],
            days: ['SUN', 'MON', 'TUE', 'WED', 'THU', 'FRI', 'SAT'],
            daysSortedByWeekStart: days.length ? days : ['SUN', 'MON', 'TUE', 'WED', 'THU', 'FRI', 'SAT'],
            minutes: this.getRange(1, 59).map(x => x.toString().padStart(2, '0')),
            seconds: this.getRange(1, 59),
            hours: this.getRange(1, 23),
            monthDays: this.getRange(1, 31),
            monthDaysWithLasts: [...[...this.getRange(1, 31).map(String)], 'L'],
            monthDaysWithOutLasts: [...[...this.getRange(1, 31).map(String)]],
            hourTypes: ['AM', 'PM']
        };
    }
    isExpressionValid() {
        if (!this.cronIsValid(this.cron)) {
            if (this.isCronFlavorQuartz) {
                this.vaildExpression.emit(false);
                this.isValid = false;
                return;
            }
            if (this.isCronFlavorStandard) {
                this.vaildExpression.emit(false);
                this.isValid = false;
            }
        }
        this.isValid = true;
    }
    /**
     * Create ranges for the different edge numbers
     *
     * @param start start from
     * @param end end to
     * @returns
     */
    getRange(start, end) {
        if (start === end) {
            return [start];
        }
        return Array.from({ length: end - start + 1 }, (_, i) => i + start);
    }
    writeValue(obj) {
        this.cron = obj;
    }
    registerOnChange(fn) {
        this.onChange = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    /** Update the cron output to that of the selected tab
     */
    onTabFocus(idx) {
        switch (idx) {
            case 0:
                if (!this.options.hideMinutesTab) {
                    this.minutesForm.setValue(this.minutesForm.value);
                }
                break;
            case 1:
                if (!this.options.hideHourlyTab) {
                    this.hourlyForm.setValue(this.hourlyForm.value);
                }
                break;
            case 2:
                if (!this.options.hideDailyTab) {
                    this.dailyForm.setValue(this.dailyForm.value);
                }
                break;
            case 3:
                if (!this.options.hideWeeklyTab) {
                    this.weeklyForm.setValue(this.weeklyForm.value);
                }
                break;
            case 4:
                if (!this.options.hideMonthlyTab) {
                    this.monthlyForm.setValue(this.monthlyForm.value);
                }
                break;
            case 5:
                if (!this.options.hideYearlyTab) {
                    this.yearlyForm.setValue(this.yearlyForm.value);
                }
                break;
            case 6:
                if (!this.options.hideAdvancedTab) {
                    this.advancedForm.setValue(this.advancedForm.value);
                }
                break;
            default:
                throw new Error('Invalid tab selected');
        }
    }
    ngOnDestroy() {
        this.unsub$.next(null);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.7", ngImport: i0, type: CronEditorComponent, deps: [{ token: i1.UntypedFormBuilder }, { token: i1$1.TranslateService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.7", type: CronEditorComponent, selector: "app-cron-editor", inputs: { options: "options", cronStartingValue: "cronStartingValue" }, outputs: { cronChange: "cronChange", vaildExpression: "vaildExpression" }, providers: [CRON_VALUE_ACCESSOR], usesOnChanges: true, ngImport: i0, template: "<mat-tab-group (selectedIndexChange)=\"onTabFocus($event)\" [selectedIndex]=\"activeTab\">\r\n\r\n  <!-- MINUTE -->\r\n  <mat-tab *ngIf=\"!options.hideMinutesTab\" label=\"{{ 'cronEditor.lbl.minutes' | translate }}\">\r\n    <div class=\"cron-editor-tab-content field-width-100\" [formGroup]=\"minutesForm\">\r\n      <span>{{('cronEditor.lbl.every' | translate) + '&nbsp;' + '&nbsp;' }}</span>\r\n      <mat-form-field>\r\n        <mat-label>{{ 'cronEditor.lbl.minutes' | translate }}</mat-label>\r\n        <mat-select formControlName=\"minutes\">\r\n          <mat-option *ngFor=\"let minute of selectOptions.minutes\" [value]=\"minute\">\r\n            {{ minute }}\r\n          </mat-option>\r\n        </mat-select>\r\n      </mat-form-field>\r\n    </div>\r\n  </mat-tab>\r\n\r\n  <!-- HOURLY -->\r\n  <mat-tab *ngIf=\"!options.hideHourlyTab\" label=\"{{ 'cronEditor.lbl.hourly' | translate }}\">\r\n    <div class=\"cron-editor-tab-content\">\r\n      <span>{{('cronEditor.lbl.every' | translate) + '&nbsp;' + '&nbsp;' }}</span>\r\n      <cron-time-picker [formGroup]=\"hourlyForm\" [hourTab]=\"true\" [use24HourTime]=\"options.use24HourTime\"\r\n        [hideSeconds]=\"options.hideSeconds ||  !isCronFlavorQuartz\">\r\n      </cron-time-picker>\r\n    </div>\r\n  </mat-tab>\r\n\r\n  <!-- DAILY -->\r\n  <mat-tab *ngIf=\"!options.hideDailyTab\" label=\"{{ 'cronEditor.lbl.daily' | translate }}\">\r\n    <div class=\"cron-editor-tab-content\" [formGroup]=\"dailyForm\">\r\n\r\n      <mat-radio-group formControlName=\"subTab\" class=\"column-stretch-start\">\r\n        <mat-radio-button name=\"subTab\" value=\"everyDays\" checked=\"checked\">\r\n\r\n          <span>{{('cronEditor.lbl.every' | translate) + '&nbsp;' + '&nbsp;' }}</span>\r\n\r\n          <mat-form-field class=\"field-width-100\" formGroupName=\"everyDays\">\r\n            <mat-label>{{ 'cronEditor.lbl.days' | translate }}</mat-label>\r\n            <mat-select formControlName=\"days\">\r\n              <mat-option *ngFor=\"let monthDay of selectOptions.monthDays\" [value]=\"monthDay\">\r\n                {{ monthDay }}\r\n              </mat-option>\r\n            </mat-select>\r\n          </mat-form-field>\r\n\r\n          {{ 'cronEditor.lbl.at' | translate }}\r\n\r\n          <cron-time-picker formGroupName=\"everyDays\" [use24HourTime]=\"options.use24HourTime\"\r\n            [hideSeconds]=\"options.hideSeconds || !isCronFlavorQuartz\">\r\n          </cron-time-picker>\r\n\r\n          <mat-form-field formGroupName=\"everyDays\" class=\"ml-12 field-width-100\">\r\n            <mat-label>{{ 'cronEditor.lbl.fromMonthday' | translate }}</mat-label>\r\n            <mat-select formControlName=\"from\">\r\n              <mat-option *ngFor=\"let monthDay of selectOptions.monthDays\" [value]=\"monthDay\">\r\n                {{ monthDay }}\r\n              </mat-option>\r\n            </mat-select>\r\n          </mat-form-field>\r\n\r\n        </mat-radio-button>\r\n\r\n        <mat-radio-button name=\"subTab\" value=\"everyWeekDay\">\r\n\r\n          <span>{{ ('cronEditor.lbl.weekDays' | translate) + '&nbsp;' + '&nbsp;' }}</span>\r\n\r\n          <cron-time-picker formGroupName=\"everyWeekDay\" [use24HourTime]=\"options.use24HourTime\"\r\n            [hideSeconds]=\"options.hideSeconds || !isCronFlavorQuartz\">\r\n          </cron-time-picker>\r\n\r\n        </mat-radio-button>\r\n      </mat-radio-group>\r\n    </div>\r\n  </mat-tab>\r\n\r\n  <!-- WEEKLY -->\r\n  <mat-tab label=\"{{ 'cronEditor.lbl.weekly' | translate }}\" *ngIf=\"!options.hideWeeklyTab\">\r\n    <div class=\"cron-editor-tab-content\">\r\n\r\n      <span>{{('cronEditor.lbl.every' | translate) + '&nbsp;' + '&nbsp;' }}</span>\r\n\r\n      <div [formGroup]=\"weeklyForm\">\r\n        <mat-checkbox *ngFor=\"let day of selectOptions.daysSortedByWeekStart\" class=\"check-weekday\" formControlName=\"{{day}}\">{{ 'cronEditor.lbl.' + day | translate }}</mat-checkbox>\r\n      </div>\r\n\r\n      <span>{{ ('cronEditor.lbl.at' | translate) + '&nbsp;' + '&nbsp;' }}</span>\r\n\r\n      <cron-time-picker [formGroup]=\"weeklyForm\" [use24HourTime]=\"options.use24HourTime\"\r\n        [hideSeconds]=\"options.hideSeconds|| !isCronFlavorQuartz\">\r\n      </cron-time-picker>\r\n    </div>\r\n  </mat-tab>\r\n\r\n  <!-- MONTHLY -->\r\n  <mat-tab label=\"{{ 'cronEditor.lbl.monthly' | translate }}\" *ngIf=\"!options.hideMonthlyTab\">\r\n    <div class=\"cron-editor-tab-content\" [formGroup]=\"monthlyForm\">\r\n      <mat-radio-group formControlName=\"subTab\" class=\"column-stretch-start\">\r\n\r\n        <mat-radio-button name=\"monthly-radio\" value=\"specificDay\">\r\n          <!-- SPECIFIC DAY -->\r\n          <span formGroupName=\"specificDay\">\r\n\r\n            {{ ('cronEditor.lbl.onThe' | translate) + '&nbsp;' + '&nbsp;' }}\r\n\r\n            <ng-container *ngIf=\"options.cronFlavor === 'quartz'\">\r\n              <mat-form-field class=\"field-width-100\">\r\n                <mat-label>{{ 'cronEditor.lbl.day' | translate }}</mat-label>\r\n                <mat-select formControlName=\"day\">\r\n                  <mat-option *ngFor=\"let monthDaysWithLast of selectOptions.monthDaysWithLasts\"\r\n                    [value]=\"monthDaysWithLast\">\r\n                    {{ (monthDaysWithLast | monthDayDisplay) | ordinalSuffix : currentLanguage }}\r\n                  </mat-option>\r\n                </mat-select>\r\n              </mat-form-field>\r\n            </ng-container>\r\n\r\n            <ng-container *ngIf=\"options.cronFlavor === 'standard'\">\r\n              <mat-form-field class=\"field-width-100\">\r\n                <mat-label>{{ 'cronEditor.lbl.day' | translate }}</mat-label>\r\n                <mat-select formControlName=\"day\">\r\n                  <mat-option *ngFor=\"let monthDaysWithOutLast of selectOptions.monthDaysWithOutLasts\"\r\n                    [value]=\"monthDaysWithOutLast\">\r\n                    {{ (monthDaysWithOutLast | monthDayDisplay) | ordinalSuffix : currentLanguage }}\r\n                  </mat-option>\r\n                </mat-select>\r\n              </mat-form-field>\r\n            </ng-container>\r\n\r\n            <span class=\"to-lowercase\">{{ '&nbsp;' + ('cronEditor.lbl.every' | translate) + '&nbsp;' }}</span>\r\n\r\n            <ng-container>\r\n              <mat-form-field>\r\n                <mat-label>{{ 'cronEditor.lbl.monthPlural' | translate }}</mat-label>\r\n                <mat-select class=\"months-small\" formControlName=\"months\">\r\n                  <mat-option *ngFor=\"let month of selectOptions.months\" [value]=\"month\">\r\n                    {{ month }}\r\n                  </mat-option>\r\n                </mat-select>\r\n              </mat-form-field>\r\n            </ng-container>\r\n\r\n            {{ ('cronEditor.lbl.atTime' | translate) + '&nbsp;' }}\r\n\r\n            <cron-time-picker [formGroup]=\"monthlyForm.controls.specificDay\" [use24HourTime]=\"options.use24HourTime\"\r\n              [hideSeconds]=\"options.hideSeconds || !isCronFlavorQuartz\">\r\n            </cron-time-picker>\r\n          </span>\r\n        </mat-radio-button>\r\n\r\n        <mat-radio-button name=\"monthly-radio\" value=\"specificWeekDay\">\r\n          <!-- SPECIFIC WEEK DAY -->\r\n          <span formGroupName=\"specificWeekDay\">\r\n\r\n            {{ ('cronEditor.lbl.onTheTriple' | translate) + '&nbsp;' }}\r\n\r\n            <mat-form-field class=\"field-width-100\">\r\n              <mat-label>{{ 'cronEditor.lbl.week' | translate }}</mat-label>\r\n              <mat-select formControlName=\"monthWeek\">\r\n                <mat-option *ngFor=\"let monthWeek of selectOptions.monthWeeks\" [value]=\"monthWeek\">\r\n                  {{ ('cronEditor.lbl.' + MonthWeeks[monthWeek]) | translate }}\r\n                </mat-option>\r\n              </mat-select>\r\n            </mat-form-field>\r\n\r\n            <mat-form-field class=\"ml-12\">\r\n              <mat-label>{{ 'cronEditor.lbl.day' | translate }}</mat-label>\r\n              <mat-select formControlName=\"day\">\r\n                <mat-option *ngFor=\"let day of selectOptions.daysSortedByWeekStart\" [value]=\"day\">\r\n                  {{ ('cronEditor.lbl.' + day) | translate }}\r\n                </mat-option>\r\n              </mat-select>\r\n            </mat-form-field>\r\n\r\n            <span class=\"to-lowercase\">{{ '&nbsp;' + ('cronEditor.lbl.every' | translate) + '&nbsp;' }}</span>\r\n\r\n            <mat-form-field>\r\n              <mat-label>{{ 'cronEditor.lbl.monthPlural' | translate }}</mat-label>\r\n              <mat-select class=\"months-small\" formControlName=\"months\">\r\n                <mat-option *ngFor=\"let month of selectOptions.months\" [value]=\"month\">\r\n                  {{ month }}\r\n                </mat-option>\r\n              </mat-select>\r\n            </mat-form-field>\r\n\r\n            {{ ('cronEditor.lbl.atTime' | translate) + '&nbsp;' }}\r\n\r\n            <cron-time-picker [formGroup]=\"monthlyForm.controls.specificWeekDay\" [use24HourTime]=\"options.use24HourTime\"\r\n              [hideSeconds]=\"options.hideSeconds || !isCronFlavorQuartz\">\r\n            </cron-time-picker>\r\n          </span>\r\n        </mat-radio-button>\r\n\r\n      </mat-radio-group>\r\n    </div>\r\n  </mat-tab>\r\n\r\n  <!-- YEARLY -->\r\n  <mat-tab label=\"{{ 'cronEditor.lbl.yearly' | translate }}\" *ngIf=\"!options.hideYearlyTab\">\r\n    <div class=\"cron-editor-tab-content\" [formGroup]=\"yearlyForm\">\r\n      <mat-radio-group formControlName=\"subTab\" class=\"column-stretch-start\">\r\n        <mat-radio-button name=\"yearly-radio\" value=\"specificMonthDay\">\r\n\r\n          {{ ('cronEditor.lbl.onThe' | translate) + '&nbsp;' + '&nbsp;' }}\r\n\r\n          <mat-form-field class=\"field-width-100\" formGroupName=\"specificMonthDay\" *ngIf=\"options.cronFlavor === 'quartz'\">\r\n            <mat-label>{{ 'cronEditor.lbl.day' | translate }}</mat-label>\r\n            <mat-select formControlName=\"day\">\r\n              <mat-option *ngFor=\"let monthDaysWithLast of selectOptions.monthDaysWithLasts\"\r\n                [value]=\"monthDaysWithLast\">\r\n                {{ (monthDaysWithLast | monthDayDisplay) | ordinalSuffix : currentLanguage }}\r\n              </mat-option>\r\n            </mat-select>\r\n          </mat-form-field>\r\n\r\n          <mat-form-field class=\"field-width-100\" formGroupName=\"specificMonthDay\" *ngIf=\"options.cronFlavor === 'standard'\">\r\n            <mat-label>{{ 'cronEditor.lbl.day' | translate }}</mat-label>\r\n            <mat-select formControlName=\"day\">\r\n              <mat-option *ngFor=\"let monthDaysWithOutLast of selectOptions.monthDaysWithOutLasts\"\r\n                [value]=\"monthDaysWithOutLast\">\r\n                {{ (monthDaysWithOutLast | monthDayDisplay) | ordinalSuffix : currentLanguage }}\r\n              </mat-option>\r\n            </mat-select>\r\n          </mat-form-field>\r\n\r\n          {{ '&nbsp;' + ('cronEditor.lbl.of' | translate) + '&nbsp;' }}\r\n\r\n          <mat-form-field formGroupName=\"specificMonthDay\">\r\n            <mat-label>{{ 'cronEditor.lbl.month' | translate }}</mat-label>\r\n            <mat-select formControlName=\"month\">\r\n              <mat-option *ngFor=\"let month of selectOptions.months\" [value]=\"month\">\r\n                {{ ('cronEditor.lbl.months.' + Months[month]) | translate }}\r\n              </mat-option>\r\n            </mat-select>\r\n          </mat-form-field>\r\n\r\n          {{ '&nbsp;' + ('cronEditor.lbl.atTime' | translate) + '&nbsp;' }}\r\n\r\n          <cron-time-picker [formGroup]=\"yearlyForm.controls.specificMonthDay\" [use24HourTime]=\"options.use24HourTime\"\r\n            [hideSeconds]=\"options.hideSeconds || !isCronFlavorQuartz\">\r\n          </cron-time-picker>\r\n        </mat-radio-button>\r\n\r\n        <mat-radio-button name=\"yearly-radio\" value=\"specificMonthWeek\">\r\n\r\n          {{ ('cronEditor.lbl.onTheDouble' | translate) + '&nbsp;' + '&nbsp;' }}\r\n\r\n          <mat-form-field class=\"field-width-100\" formGroupName=\"specificMonthWeek\">\r\n            <mat-label>{{ 'cronEditor.lbl.week' | translate }}</mat-label>\r\n            <mat-select formControlName=\"monthWeek\">\r\n              <mat-option *ngFor=\"let monthWeek of selectOptions.monthWeeks\" [value]=\"monthWeek\">\r\n                {{ ('cronEditor.lbl.' + MonthWeeks[monthWeek]) | translate }}\r\n              </mat-option>\r\n            </mat-select>\r\n          </mat-form-field>\r\n\r\n          <mat-form-field formGroupName=\"specificMonthWeek\">\r\n            <mat-label>{{ 'cronEditor.lbl.day' | translate }}</mat-label>\r\n            <mat-select formControlName=\"day\">\r\n              <mat-option *ngFor=\"let day of selectOptions.daysSortedByWeekStart\" [value]=\"day\">\r\n                {{ ('cronEditor.lbl.' + day) | translate }}\r\n              </mat-option>\r\n            </mat-select>\r\n          </mat-form-field>\r\n\r\n          {{ '&nbsp;' + ('cronEditor.lbl.of' | translate) + '&nbsp;' }}\r\n\r\n          <mat-form-field formGroupName=\"specificMonthWeek\">\r\n            <mat-label>{{ 'cronEditor.lbl.month' | translate }}</mat-label>\r\n            <mat-select formControlName=\"month\">\r\n              <mat-option *ngFor=\"let month of selectOptions.months\" [value]=\"month\">\r\n                {{ ('cronEditor.lbl.months.' + Months[month]) | translate }}\r\n              </mat-option>\r\n            </mat-select>\r\n          </mat-form-field>\r\n\r\n          {{ ('cronEditor.lbl.atTime' | translate) + '&nbsp;' }}\r\n\r\n          <cron-time-picker [formGroup]=\"yearlyForm.controls.specificMonthWeek\" [use24HourTime]=\"options.use24HourTime\"\r\n            [hideSeconds]=\"options.hideSeconds || !isCronFlavorQuartz\">\r\n          </cron-time-picker>\r\n        </mat-radio-button>\r\n      </mat-radio-group>\r\n    </div>\r\n  </mat-tab>\r\n\r\n  <!-- ADVANCED -->\r\n  <mat-tab label=\"{{ 'cronEditor.lbl.advanced' | translate }}\" *ngIf=\"!options.hideAdvancedTab\">\r\n    <div class=\"cron-editor-tab-content\" [formGroup]=\"advancedForm\">\r\n      <mat-form-field>\r\n        <mat-label>{{ 'cronEditor.lbl.expression' | translate }}</mat-label>\r\n        <input matInput type=\"text\" formControlName=\"expression\">\r\n      </mat-form-field>\r\n    </div>\r\n  </mat-tab>\r\n\r\n</mat-tab-group>", styles: [".cron-editor-tab-content{height:200px;margin-top:24px;margin-left:24px;border-radius:8px}.to-lowercase{text-transform:lowercase}.check-weekday{margin-left:12px}.field-width-100 ::ng-deep .mat-form-field-infix{width:100px}.column-stretch-start{display:flex;flex-flow:column;justify-content:start;align-items:stretch}\n"], dependencies: [{ kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { kind: "directive", type: i1.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { kind: "directive", type: i1.FormControlName, selector: "[formControlName]", inputs: ["formControlName", "disabled", "ngModel"], outputs: ["ngModelChange"] }, { kind: "directive", type: i1.FormGroupName, selector: "[formGroupName]", inputs: ["formGroupName"] }, { kind: "component", type: i4$1.MatTab, selector: "mat-tab", inputs: ["disabled"], exportAs: ["matTab"] }, { kind: "component", type: i4$1.MatTabGroup, selector: "mat-tab-group", inputs: ["color", "disableRipple", "fitInkBarToContent", "mat-stretch-tabs"], exportAs: ["matTabGroup"] }, { kind: "component", type: i3.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i3.MatLabel, selector: "mat-label" }, { kind: "component", type: i4.MatSelect, selector: "mat-select", inputs: ["disabled", "disableRipple", "tabIndex", "hideSingleSelectionIndicator"], exportAs: ["matSelect"] }, { kind: "component", type: i5.MatOption, selector: "mat-option", exportAs: ["matOption"] }, { kind: "directive", type: i8.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { kind: "directive", type: i9.MatRadioGroup, selector: "mat-radio-group", exportAs: ["matRadioGroup"] }, { kind: "component", type: i9.MatRadioButton, selector: "mat-radio-button", inputs: ["disableRipple", "tabIndex"], exportAs: ["matRadioButton"] }, { kind: "component", type: i10.MatCheckbox, selector: "mat-checkbox", inputs: ["disableRipple", "color", "tabIndex"], exportAs: ["matCheckbox"] }, { kind: "component", type: TimePickerComponent, selector: "cron-time-picker", inputs: ["disabled", "use24HourTime", "hideHours", "hideMinutes", "hideSeconds", "hourTab"] }, { kind: "pipe", type: i1$1.TranslatePipe, name: "translate" }, { kind: "pipe", type: MonthDayDisplayPipe, name: "monthDayDisplay" }, { kind: "pipe", type: OrdinalSuffixPipe, name: "ordinalSuffix" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.7", ngImport: i0, type: CronEditorComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-cron-editor', providers: [CRON_VALUE_ACCESSOR], changeDetection: ChangeDetectionStrategy.OnPush, template: "<mat-tab-group (selectedIndexChange)=\"onTabFocus($event)\" [selectedIndex]=\"activeTab\">\r\n\r\n  <!-- MINUTE -->\r\n  <mat-tab *ngIf=\"!options.hideMinutesTab\" label=\"{{ 'cronEditor.lbl.minutes' | translate }}\">\r\n    <div class=\"cron-editor-tab-content field-width-100\" [formGroup]=\"minutesForm\">\r\n      <span>{{('cronEditor.lbl.every' | translate) + '&nbsp;' + '&nbsp;' }}</span>\r\n      <mat-form-field>\r\n        <mat-label>{{ 'cronEditor.lbl.minutes' | translate }}</mat-label>\r\n        <mat-select formControlName=\"minutes\">\r\n          <mat-option *ngFor=\"let minute of selectOptions.minutes\" [value]=\"minute\">\r\n            {{ minute }}\r\n          </mat-option>\r\n        </mat-select>\r\n      </mat-form-field>\r\n    </div>\r\n  </mat-tab>\r\n\r\n  <!-- HOURLY -->\r\n  <mat-tab *ngIf=\"!options.hideHourlyTab\" label=\"{{ 'cronEditor.lbl.hourly' | translate }}\">\r\n    <div class=\"cron-editor-tab-content\">\r\n      <span>{{('cronEditor.lbl.every' | translate) + '&nbsp;' + '&nbsp;' }}</span>\r\n      <cron-time-picker [formGroup]=\"hourlyForm\" [hourTab]=\"true\" [use24HourTime]=\"options.use24HourTime\"\r\n        [hideSeconds]=\"options.hideSeconds ||  !isCronFlavorQuartz\">\r\n      </cron-time-picker>\r\n    </div>\r\n  </mat-tab>\r\n\r\n  <!-- DAILY -->\r\n  <mat-tab *ngIf=\"!options.hideDailyTab\" label=\"{{ 'cronEditor.lbl.daily' | translate }}\">\r\n    <div class=\"cron-editor-tab-content\" [formGroup]=\"dailyForm\">\r\n\r\n      <mat-radio-group formControlName=\"subTab\" class=\"column-stretch-start\">\r\n        <mat-radio-button name=\"subTab\" value=\"everyDays\" checked=\"checked\">\r\n\r\n          <span>{{('cronEditor.lbl.every' | translate) + '&nbsp;' + '&nbsp;' }}</span>\r\n\r\n          <mat-form-field class=\"field-width-100\" formGroupName=\"everyDays\">\r\n            <mat-label>{{ 'cronEditor.lbl.days' | translate }}</mat-label>\r\n            <mat-select formControlName=\"days\">\r\n              <mat-option *ngFor=\"let monthDay of selectOptions.monthDays\" [value]=\"monthDay\">\r\n                {{ monthDay }}\r\n              </mat-option>\r\n            </mat-select>\r\n          </mat-form-field>\r\n\r\n          {{ 'cronEditor.lbl.at' | translate }}\r\n\r\n          <cron-time-picker formGroupName=\"everyDays\" [use24HourTime]=\"options.use24HourTime\"\r\n            [hideSeconds]=\"options.hideSeconds || !isCronFlavorQuartz\">\r\n          </cron-time-picker>\r\n\r\n          <mat-form-field formGroupName=\"everyDays\" class=\"ml-12 field-width-100\">\r\n            <mat-label>{{ 'cronEditor.lbl.fromMonthday' | translate }}</mat-label>\r\n            <mat-select formControlName=\"from\">\r\n              <mat-option *ngFor=\"let monthDay of selectOptions.monthDays\" [value]=\"monthDay\">\r\n                {{ monthDay }}\r\n              </mat-option>\r\n            </mat-select>\r\n          </mat-form-field>\r\n\r\n        </mat-radio-button>\r\n\r\n        <mat-radio-button name=\"subTab\" value=\"everyWeekDay\">\r\n\r\n          <span>{{ ('cronEditor.lbl.weekDays' | translate) + '&nbsp;' + '&nbsp;' }}</span>\r\n\r\n          <cron-time-picker formGroupName=\"everyWeekDay\" [use24HourTime]=\"options.use24HourTime\"\r\n            [hideSeconds]=\"options.hideSeconds || !isCronFlavorQuartz\">\r\n          </cron-time-picker>\r\n\r\n        </mat-radio-button>\r\n      </mat-radio-group>\r\n    </div>\r\n  </mat-tab>\r\n\r\n  <!-- WEEKLY -->\r\n  <mat-tab label=\"{{ 'cronEditor.lbl.weekly' | translate }}\" *ngIf=\"!options.hideWeeklyTab\">\r\n    <div class=\"cron-editor-tab-content\">\r\n\r\n      <span>{{('cronEditor.lbl.every' | translate) + '&nbsp;' + '&nbsp;' }}</span>\r\n\r\n      <div [formGroup]=\"weeklyForm\">\r\n        <mat-checkbox *ngFor=\"let day of selectOptions.daysSortedByWeekStart\" class=\"check-weekday\" formControlName=\"{{day}}\">{{ 'cronEditor.lbl.' + day | translate }}</mat-checkbox>\r\n      </div>\r\n\r\n      <span>{{ ('cronEditor.lbl.at' | translate) + '&nbsp;' + '&nbsp;' }}</span>\r\n\r\n      <cron-time-picker [formGroup]=\"weeklyForm\" [use24HourTime]=\"options.use24HourTime\"\r\n        [hideSeconds]=\"options.hideSeconds|| !isCronFlavorQuartz\">\r\n      </cron-time-picker>\r\n    </div>\r\n  </mat-tab>\r\n\r\n  <!-- MONTHLY -->\r\n  <mat-tab label=\"{{ 'cronEditor.lbl.monthly' | translate }}\" *ngIf=\"!options.hideMonthlyTab\">\r\n    <div class=\"cron-editor-tab-content\" [formGroup]=\"monthlyForm\">\r\n      <mat-radio-group formControlName=\"subTab\" class=\"column-stretch-start\">\r\n\r\n        <mat-radio-button name=\"monthly-radio\" value=\"specificDay\">\r\n          <!-- SPECIFIC DAY -->\r\n          <span formGroupName=\"specificDay\">\r\n\r\n            {{ ('cronEditor.lbl.onThe' | translate) + '&nbsp;' + '&nbsp;' }}\r\n\r\n            <ng-container *ngIf=\"options.cronFlavor === 'quartz'\">\r\n              <mat-form-field class=\"field-width-100\">\r\n                <mat-label>{{ 'cronEditor.lbl.day' | translate }}</mat-label>\r\n                <mat-select formControlName=\"day\">\r\n                  <mat-option *ngFor=\"let monthDaysWithLast of selectOptions.monthDaysWithLasts\"\r\n                    [value]=\"monthDaysWithLast\">\r\n                    {{ (monthDaysWithLast | monthDayDisplay) | ordinalSuffix : currentLanguage }}\r\n                  </mat-option>\r\n                </mat-select>\r\n              </mat-form-field>\r\n            </ng-container>\r\n\r\n            <ng-container *ngIf=\"options.cronFlavor === 'standard'\">\r\n              <mat-form-field class=\"field-width-100\">\r\n                <mat-label>{{ 'cronEditor.lbl.day' | translate }}</mat-label>\r\n                <mat-select formControlName=\"day\">\r\n                  <mat-option *ngFor=\"let monthDaysWithOutLast of selectOptions.monthDaysWithOutLasts\"\r\n                    [value]=\"monthDaysWithOutLast\">\r\n                    {{ (monthDaysWithOutLast | monthDayDisplay) | ordinalSuffix : currentLanguage }}\r\n                  </mat-option>\r\n                </mat-select>\r\n              </mat-form-field>\r\n            </ng-container>\r\n\r\n            <span class=\"to-lowercase\">{{ '&nbsp;' + ('cronEditor.lbl.every' | translate) + '&nbsp;' }}</span>\r\n\r\n            <ng-container>\r\n              <mat-form-field>\r\n                <mat-label>{{ 'cronEditor.lbl.monthPlural' | translate }}</mat-label>\r\n                <mat-select class=\"months-small\" formControlName=\"months\">\r\n                  <mat-option *ngFor=\"let month of selectOptions.months\" [value]=\"month\">\r\n                    {{ month }}\r\n                  </mat-option>\r\n                </mat-select>\r\n              </mat-form-field>\r\n            </ng-container>\r\n\r\n            {{ ('cronEditor.lbl.atTime' | translate) + '&nbsp;' }}\r\n\r\n            <cron-time-picker [formGroup]=\"monthlyForm.controls.specificDay\" [use24HourTime]=\"options.use24HourTime\"\r\n              [hideSeconds]=\"options.hideSeconds || !isCronFlavorQuartz\">\r\n            </cron-time-picker>\r\n          </span>\r\n        </mat-radio-button>\r\n\r\n        <mat-radio-button name=\"monthly-radio\" value=\"specificWeekDay\">\r\n          <!-- SPECIFIC WEEK DAY -->\r\n          <span formGroupName=\"specificWeekDay\">\r\n\r\n            {{ ('cronEditor.lbl.onTheTriple' | translate) + '&nbsp;' }}\r\n\r\n            <mat-form-field class=\"field-width-100\">\r\n              <mat-label>{{ 'cronEditor.lbl.week' | translate }}</mat-label>\r\n              <mat-select formControlName=\"monthWeek\">\r\n                <mat-option *ngFor=\"let monthWeek of selectOptions.monthWeeks\" [value]=\"monthWeek\">\r\n                  {{ ('cronEditor.lbl.' + MonthWeeks[monthWeek]) | translate }}\r\n                </mat-option>\r\n              </mat-select>\r\n            </mat-form-field>\r\n\r\n            <mat-form-field class=\"ml-12\">\r\n              <mat-label>{{ 'cronEditor.lbl.day' | translate }}</mat-label>\r\n              <mat-select formControlName=\"day\">\r\n                <mat-option *ngFor=\"let day of selectOptions.daysSortedByWeekStart\" [value]=\"day\">\r\n                  {{ ('cronEditor.lbl.' + day) | translate }}\r\n                </mat-option>\r\n              </mat-select>\r\n            </mat-form-field>\r\n\r\n            <span class=\"to-lowercase\">{{ '&nbsp;' + ('cronEditor.lbl.every' | translate) + '&nbsp;' }}</span>\r\n\r\n            <mat-form-field>\r\n              <mat-label>{{ 'cronEditor.lbl.monthPlural' | translate }}</mat-label>\r\n              <mat-select class=\"months-small\" formControlName=\"months\">\r\n                <mat-option *ngFor=\"let month of selectOptions.months\" [value]=\"month\">\r\n                  {{ month }}\r\n                </mat-option>\r\n              </mat-select>\r\n            </mat-form-field>\r\n\r\n            {{ ('cronEditor.lbl.atTime' | translate) + '&nbsp;' }}\r\n\r\n            <cron-time-picker [formGroup]=\"monthlyForm.controls.specificWeekDay\" [use24HourTime]=\"options.use24HourTime\"\r\n              [hideSeconds]=\"options.hideSeconds || !isCronFlavorQuartz\">\r\n            </cron-time-picker>\r\n          </span>\r\n        </mat-radio-button>\r\n\r\n      </mat-radio-group>\r\n    </div>\r\n  </mat-tab>\r\n\r\n  <!-- YEARLY -->\r\n  <mat-tab label=\"{{ 'cronEditor.lbl.yearly' | translate }}\" *ngIf=\"!options.hideYearlyTab\">\r\n    <div class=\"cron-editor-tab-content\" [formGroup]=\"yearlyForm\">\r\n      <mat-radio-group formControlName=\"subTab\" class=\"column-stretch-start\">\r\n        <mat-radio-button name=\"yearly-radio\" value=\"specificMonthDay\">\r\n\r\n          {{ ('cronEditor.lbl.onThe' | translate) + '&nbsp;' + '&nbsp;' }}\r\n\r\n          <mat-form-field class=\"field-width-100\" formGroupName=\"specificMonthDay\" *ngIf=\"options.cronFlavor === 'quartz'\">\r\n            <mat-label>{{ 'cronEditor.lbl.day' | translate }}</mat-label>\r\n            <mat-select formControlName=\"day\">\r\n              <mat-option *ngFor=\"let monthDaysWithLast of selectOptions.monthDaysWithLasts\"\r\n                [value]=\"monthDaysWithLast\">\r\n                {{ (monthDaysWithLast | monthDayDisplay) | ordinalSuffix : currentLanguage }}\r\n              </mat-option>\r\n            </mat-select>\r\n          </mat-form-field>\r\n\r\n          <mat-form-field class=\"field-width-100\" formGroupName=\"specificMonthDay\" *ngIf=\"options.cronFlavor === 'standard'\">\r\n            <mat-label>{{ 'cronEditor.lbl.day' | translate }}</mat-label>\r\n            <mat-select formControlName=\"day\">\r\n              <mat-option *ngFor=\"let monthDaysWithOutLast of selectOptions.monthDaysWithOutLasts\"\r\n                [value]=\"monthDaysWithOutLast\">\r\n                {{ (monthDaysWithOutLast | monthDayDisplay) | ordinalSuffix : currentLanguage }}\r\n              </mat-option>\r\n            </mat-select>\r\n          </mat-form-field>\r\n\r\n          {{ '&nbsp;' + ('cronEditor.lbl.of' | translate) + '&nbsp;' }}\r\n\r\n          <mat-form-field formGroupName=\"specificMonthDay\">\r\n            <mat-label>{{ 'cronEditor.lbl.month' | translate }}</mat-label>\r\n            <mat-select formControlName=\"month\">\r\n              <mat-option *ngFor=\"let month of selectOptions.months\" [value]=\"month\">\r\n                {{ ('cronEditor.lbl.months.' + Months[month]) | translate }}\r\n              </mat-option>\r\n            </mat-select>\r\n          </mat-form-field>\r\n\r\n          {{ '&nbsp;' + ('cronEditor.lbl.atTime' | translate) + '&nbsp;' }}\r\n\r\n          <cron-time-picker [formGroup]=\"yearlyForm.controls.specificMonthDay\" [use24HourTime]=\"options.use24HourTime\"\r\n            [hideSeconds]=\"options.hideSeconds || !isCronFlavorQuartz\">\r\n          </cron-time-picker>\r\n        </mat-radio-button>\r\n\r\n        <mat-radio-button name=\"yearly-radio\" value=\"specificMonthWeek\">\r\n\r\n          {{ ('cronEditor.lbl.onTheDouble' | translate) + '&nbsp;' + '&nbsp;' }}\r\n\r\n          <mat-form-field class=\"field-width-100\" formGroupName=\"specificMonthWeek\">\r\n            <mat-label>{{ 'cronEditor.lbl.week' | translate }}</mat-label>\r\n            <mat-select formControlName=\"monthWeek\">\r\n              <mat-option *ngFor=\"let monthWeek of selectOptions.monthWeeks\" [value]=\"monthWeek\">\r\n                {{ ('cronEditor.lbl.' + MonthWeeks[monthWeek]) | translate }}\r\n              </mat-option>\r\n            </mat-select>\r\n          </mat-form-field>\r\n\r\n          <mat-form-field formGroupName=\"specificMonthWeek\">\r\n            <mat-label>{{ 'cronEditor.lbl.day' | translate }}</mat-label>\r\n            <mat-select formControlName=\"day\">\r\n              <mat-option *ngFor=\"let day of selectOptions.daysSortedByWeekStart\" [value]=\"day\">\r\n                {{ ('cronEditor.lbl.' + day) | translate }}\r\n              </mat-option>\r\n            </mat-select>\r\n          </mat-form-field>\r\n\r\n          {{ '&nbsp;' + ('cronEditor.lbl.of' | translate) + '&nbsp;' }}\r\n\r\n          <mat-form-field formGroupName=\"specificMonthWeek\">\r\n            <mat-label>{{ 'cronEditor.lbl.month' | translate }}</mat-label>\r\n            <mat-select formControlName=\"month\">\r\n              <mat-option *ngFor=\"let month of selectOptions.months\" [value]=\"month\">\r\n                {{ ('cronEditor.lbl.months.' + Months[month]) | translate }}\r\n              </mat-option>\r\n            </mat-select>\r\n          </mat-form-field>\r\n\r\n          {{ ('cronEditor.lbl.atTime' | translate) + '&nbsp;' }}\r\n\r\n          <cron-time-picker [formGroup]=\"yearlyForm.controls.specificMonthWeek\" [use24HourTime]=\"options.use24HourTime\"\r\n            [hideSeconds]=\"options.hideSeconds || !isCronFlavorQuartz\">\r\n          </cron-time-picker>\r\n        </mat-radio-button>\r\n      </mat-radio-group>\r\n    </div>\r\n  </mat-tab>\r\n\r\n  <!-- ADVANCED -->\r\n  <mat-tab label=\"{{ 'cronEditor.lbl.advanced' | translate }}\" *ngIf=\"!options.hideAdvancedTab\">\r\n    <div class=\"cron-editor-tab-content\" [formGroup]=\"advancedForm\">\r\n      <mat-form-field>\r\n        <mat-label>{{ 'cronEditor.lbl.expression' | translate }}</mat-label>\r\n        <input matInput type=\"text\" formControlName=\"expression\">\r\n      </mat-form-field>\r\n    </div>\r\n  </mat-tab>\r\n\r\n</mat-tab-group>", styles: [".cron-editor-tab-content{height:200px;margin-top:24px;margin-left:24px;border-radius:8px}.to-lowercase{text-transform:lowercase}.check-weekday{margin-left:12px}.field-width-100 ::ng-deep .mat-form-field-infix{width:100px}.column-stretch-start{display:flex;flex-flow:column;justify-content:start;align-items:stretch}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.UntypedFormBuilder }, { type: i1$1.TranslateService }]; }, propDecorators: { options: [{
                type: Input
            }], cronStartingValue: [{
                type: Input
            }], cronChange: [{
                type: Output
            }], vaildExpression: [{
                type: Output
            }] } });

class CronEditorModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.7", ngImport: i0, type: CronEditorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.2.7", ngImport: i0, type: CronEditorModule, declarations: [TimePickerComponent, CronEditorComponent, MonthDayDisplayPipe, OrdinalSuffixPipe], imports: [CommonModule,
            ReactiveFormsModule,
            MatTabsModule,
            MatListModule,
            MatSelectModule,
            MatDatepickerModule,
            MatInputModule,
            MatRadioModule,
            MatCheckboxModule, i1$1.TranslateModule], exports: [TimePickerComponent, CronEditorComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.2.7", ngImport: i0, type: CronEditorModule, imports: [CommonModule,
            ReactiveFormsModule,
            MatTabsModule,
            MatListModule,
            MatSelectModule,
            MatDatepickerModule,
            MatInputModule,
            MatRadioModule,
            MatCheckboxModule,
            TranslateModule.forChild()] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.7", ngImport: i0, type: CronEditorModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        ReactiveFormsModule,
                        MatTabsModule,
                        MatListModule,
                        MatSelectModule,
                        MatDatepickerModule,
                        MatInputModule,
                        MatRadioModule,
                        MatCheckboxModule,
                        TranslateModule.forChild()
                    ],
                    declarations: [TimePickerComponent, CronEditorComponent, MonthDayDisplayPipe, OrdinalSuffixPipe],
                    exports: [TimePickerComponent, CronEditorComponent]
                }]
        }] });

/*
 * Public API Surface of cron-editor
 */

/**
 * Generated bundle index. Do not edit.
 */

export { CRON_VALUE_ACCESSOR, CronEditorComponent, CronEditorModule, Days, MonthDayDisplayPipe, MonthWeeks, Months, OrdinalSuffixPipe, Tabs, TimePickerComponent };
//# sourceMappingURL=tarktech-ngx-cron-editor.mjs.map
